Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 8568)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 8569)
@@ -138,4 +138,9 @@
     <None Include="Properties\AssemblyInfo.cs.frame" />
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="RunCollectionStatisticalTabularView.resx">
+      <DependentUpon>RunCollectionStatisticalTabularView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs	(revision 8568)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs	(revision 8569)
@@ -234,4 +234,22 @@
       }
     }
+
+    private void addValuesButton_Click(object sender, EventArgs e) {
+      string resultName = (string)dataTableComboBox.SelectedItem;
+      string rowName = (string)dataRowComboBox.SelectedItem;
+      var runs = Content.Where(x => x.Results.ContainsKey(resultName));
+      StringMatrix sm = (StringMatrix)stringConvertibleMatrixView.Content;
+
+      for (int i = 0; i < runs.Count(); i++) {
+        IRun run = runs.ElementAt(i);
+
+        for (int j = 0; j < sm.ColumnNames.Count(); j++) {
+          string newResultName = resultName + " " + rowName + " " + sm.ColumnNames.ElementAt(j);
+          run.Results.Add(new KeyValuePair<string, Core.IItem>(newResultName, new DoubleValue(double.Parse(sm[i, j]))));
+        }
+      }
+      //update column names of run collection
+      Content.Modify();
+    }
   }
 }
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.designer.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.designer.cs	(revision 8568)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.designer.cs	(revision 8569)
@@ -51,4 +51,5 @@
       this.dataTableComboBox = new System.Windows.Forms.ComboBox();
       this.addLineToChart = new System.Windows.Forms.Button();
+      this.addValuesButton = new System.Windows.Forms.Button();
       this.SuspendLayout();
       // 
@@ -121,6 +122,18 @@
       this.addLineToChart.Click += new System.EventHandler(this.addLineToChart_Click);
       // 
+      // addValuesButton
+      // 
+      this.addValuesButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.addValuesButton.Location = new System.Drawing.Point(281, 359);
+      this.addValuesButton.Name = "addValuesButton";
+      this.addValuesButton.Size = new System.Drawing.Size(133, 23);
+      this.addValuesButton.TabIndex = 10;
+      this.addValuesButton.Text = "Add Values to Results";
+      this.addValuesButton.UseVisualStyleBackColor = true;
+      this.addValuesButton.Click += new System.EventHandler(this.addValuesButton_Click);
+      // 
       // RunCollectionStatisticalTabularView
       // 
+      this.Controls.Add(this.addValuesButton);
       this.Controls.Add(this.addLineToChart);
       this.Controls.Add(this.dataRowComboBox);
@@ -143,4 +156,5 @@
     private System.Windows.Forms.ComboBox dataTableComboBox;
     private System.Windows.Forms.Button addLineToChart;
+    private System.Windows.Forms.Button addValuesButton;
   }
 }